namespace foo {

  /** \brief A generic factory base class. */
  template<typename TT>
  class Foo {
  public:
    virtual ~Foo() {}
    virtual TT * create() = 0;
  };

}

namespace bar {

  /** \brief An interface for a factory implementation. */
  typedef foo::Foo<double> BarBase;

  /** \brief A factory implementation. */
  class Bar : public BarBase {
  public:
    virtual double * create() { return new double(42); }
  };

}
